Attribute VB_Name = "M_Directx"
Option Explicit

'La sub qui permet l'initialisation de DX
Public Sub Main()

'Initialisation DX
    'on va dire que directdraw est un objet directx qui va nous servir a afficher les images :
    Set dd = dx.DirectDrawCreate("")
    
    dd.SetCooperativeLevel Form1.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWREBOOT
    dd.SetDisplayMode 800, 600, 32, 0, DDSDM_DEFAULT
    
    'Direct Input
    Set DI = dx.DirectInputCreate()
    Set DIdevice = DI.CreateDevice("GUID_SysKeyboard")
    DIdevice.SetCommonDataFormat DIFORMAT_KEYBOARD
    DIdevice.SetCooperativeLevel Form1.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    DIdevice.Acquire
     
    ddsd.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    ddsd.ddscaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX Or DDSCAPS_VIDEOMEMORY
    ddsd.lBackBufferCount = 1
    
    'Surface
    Set Primary = dd.CreateSurface(ddsd)
    ddscaps.lCaps = DDSCAPS_BACKBUFFER Or DDSCAPS_VIDEOMEMORY
    Set Backbuffer = Primary.GetAttachedSurface(ddscaps)
    
    ' DirectSound
    
    Set DS = dx.DirectSoundCreate("")
    DS.SetCooperativeLevel Form1.hWnd, DSSCL_PRIORITY
    
    If Err.Number <> 0 Then
        MsgBox "Impossible de dmarrer DirectSound. Vrifiez que votre carte son est bien installe."
        End
    End If
    

    bufferDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
    waveFormat.nFormatTag = WAVE_FORMAT_PCM
    waveFormat.nChannels = 2
    waveFormat.lSamplesPerSec = 22050
    waveFormat.nBitsPerSample = 16
    waveFormat.nBlockAlign = waveFormat.nBitsPerSample / 8 * waveFormat.nChannels
    waveFormat.lAvgBytesPerSec = waveFormat.lSamplesPerSec * waveFormat.nBlockAlign
    
    
    Set loader = Nothing
    Set loader = dx.DirectMusicLoaderCreate()
    Set perf = dx.DirectMusicPerformanceCreate()
    Call perf.Init(Nothing, 0)
    perf.SetPort -1, 80
    
    Call Loading
    
End Sub


'La sub qui permet le chargement des images et constantes
Public Sub Loading()

Dim path As String
Dim length
Dim i As Integer

    BltFxRevert.lDDFX = DDBLTFX_MIRRORLEFTRIGHT
    
    ckBlack.high = vbBlack
    ckBlack.low = vbBlack
    ckWhite.high = vbWhite
    ckWhite.low = vbWhite
    
    Set Sintro = DS.CreateSoundBufferFromFile(App.path & "\son\intro.wav", bufferDesc, waveFormat)
    
    'Utilisation de la fonction pour charger gif et jpeg
    For i = 0 To 4
        Set SBackGround(i) = CreateSurfaceFromFile(dd, App.path & "\fond\Image0" & i & ".jpg", ddsdBackGround(i))
    Next i
    
    Set SBarre = CreateSurfaceFromFile(dd, App.path & "\image\barre.bmp", ddsdBarre)
    SBarre.SetColorKey DDCKEY_SRCBLT, ckWhite
    'Chargement de la vie et du cosmos
    Set SVie = CreateSurfaceFromFile(dd, App.path & "\image\vie.jpg", ddsdVie)
    Set SCosmos = CreateSurfaceFromFile(dd, App.path & "\image\cos.jpg", ddsdCosmos)
    
    Set SRound(0) = CreateSurfaceFromFile(dd, App.path & "\image\r.bmp", ddsdRound(0))
    Set SRound(1) = CreateSurfaceFromFile(dd, App.path & "\image\f.bmp", ddsdRound(1))
    Set SRound(2) = CreateSurfaceFromFile(dd, App.path & "\image\e.bmp", ddsdRound(2))
    SRound(0).SetColorKey DDCKEY_SRCBLT, ckBlack
    SRound(1).SetColorKey DDCKEY_SRCBLT, ckBlack
    SRound(2).SetColorKey DDCKEY_SRCBLT, ckBlack
    
    Set SHurt(0) = DS.CreateSoundBufferFromFile(App.path & "\son\h0.wav", bufferDesc, waveFormat)
    Set SHurt(1) = DS.CreateSoundBufferFromFile(App.path & "\son\h1.wav", bufferDesc, waveFormat)
    Set SHurt(2) = DS.CreateSoundBufferFromFile(App.path & "\son\h2.wav", bufferDesc, waveFormat)
    Set SHurt(3) = DS.CreateSoundBufferFromFile(App.path & "\son\h3.wav", bufferDesc, waveFormat)
    Set SHurt(4) = DS.CreateSoundBufferFromFile(App.path & "\son\h4.wav", bufferDesc, waveFormat)
    Set SHurt(5) = DS.CreateSoundBufferFromFile(App.path & "\son\h5.wav", bufferDesc, waveFormat)
    
    Set SDefend(0) = DS.CreateSoundBufferFromFile(App.path & "\son\d0.wav", bufferDesc, waveFormat)
    Set SDefend(1) = DS.CreateSoundBufferFromFile(App.path & "\son\d1.wav", bufferDesc, waveFormat)
    
    
    ComWicked.Time = 160
    ComWicked.NbrPicture = 4
    ComWicked.State = "w"
    
    Set MusicTheme = loader.LoadSegment(App.path & "\musique\mtheme.mid")

    length = Len(App.path & "\musique\mtheme.mid")
    Do While path <> "\"
        path = Mid(App.path & "\musique\mtheme.mid", length, 1)
        length = length - 1
    Loop
    MusicTheme.SetStandardMidiFile

    Set MusicBattle = loader.LoadSegment(App.path & "\musique\mbattle.mid")

    length = Len(App.path & "\musique\mbattle.mid")
    Do While path <> "\"
        path = Mid(App.path & "\musique\mbattle.mid", length, 1)
        length = length - 1
    Loop

    perf.SetMasterAutoDownload True
    MusicBattle.SetStandardMidiFile

    
    
    RoundStart = True
    RoundEnd = False
    
    Call LoadDifficulty
    
End Sub

Public Sub Rendu()
    
    'Joue la musique
    perf.SetMasterVolume 50 * 10
    Call perf.PlaySegment(MusicBattle, 0, 0)
    
    'Affiche le Round
    If RoundStart = True Then Call Load_Round
        
    Do
        
    '****** Affiche le fond *****
        Backbuffer.BltColorFill ddRect(0, 0, 0, 0), vbBlack
        
        Backbuffer.Blt ddRect(0, 0, 800, 326), SBackGround(NbrBackGround), ddRect(0, 0, 0, 0), DDBLT_WAIT
        
        Backbuffer.SetForeColor vbWhite
        
        If PlayerCosmos < 0 Then PlayerCosmos = 0
        If WickedCosmos > 800 Then WickedCosmos = 800
        If PlayerCosmos > 300 Then PlayerCosmos = 300
        If WickedCosmos < 500 Then WickedCosmos = 500
        
        'Vie et Cosmos Player
        Backbuffer.Blt ddRect(0, 5, PlayerLife, 5 + ddsdVie.lHeight), SVie, ddRect(0, 0, 0, 0), DDBLT_WAIT
        Backbuffer.Blt ddRect(0, 20, PlayerCosmos, 20 + ddsdCosmos.lHeight), SCosmos, ddRect(0, 0, 0, 0), DDBLT_WAIT
        Backbuffer.DrawText 10, 35, Player.Name, False
    
        'Vie et Cosmos Wicked
        Backbuffer.Blt ddRect(WickedLife, 5, 800, 5 + ddsdVie.lHeight), SVie, ddRect(0, 0, 0, 0), DDBLT_WAIT
        Backbuffer.Blt ddRect(WickedCosmos, 20, 800, 20 + ddsdCosmos.lHeight), SCosmos, ddRect(0, 0, 0, 0), DDBLT_WAIT
        Backbuffer.DrawText 750, 35, ComWicked.Name, False
        
        Backbuffer.SetForeColor vbRed
        Backbuffer.DrawText 365, 5, " <-  Vie  -> ", False
        Backbuffer.SetForeColor vbBlue
        Backbuffer.DrawText 350, 18, " <-  Cosmos  -> ", False
        
        TimePlayed = dx.TickCount
        
        If TimePlayed_State = 0 Then
            TimePlayed_2 = dx.TickCount
            TimePlayed_State = 1
        End If
        
        If TimePlayed - TimePlayed_2 > 1000 Then
            TimePlayed_State = 0
            AbsoluteTimePlayed = AbsoluteTimePlayed + 1
            If ComWicked.State = "die" Or Player.State = "die" Then RoundEndTime = RoundEndTime + 1
            If PlayerCosmos < 300 Then PlayerCosmos = PlayerCosmos + 2
            If WickedCosmos > 500 Then WickedCosmos = WickedCosmos - 2
        End If
        
        Backbuffer.SetForeColor vbYellow
        Backbuffer.DrawText 380, 40, "< " & AbsoluteTimePlayed & " >", False
        
        Backbuffer.SetForeColor vbWhite
        Backbuffer.DrawText 50, 3, PlayerLife & " / 300", False
        Backbuffer.DrawText 50, 18, PlayerCosmos & " / 300", False
        Backbuffer.DrawText 700, 3, (800 - WickedLife) & " / 300", False
        Backbuffer.DrawText 700, 18, (800 - WickedCosmos) & " / 300", False
        
        If PlayerLife <= 0 Then
            Player.State = "die"
            Wicked = 0
            If RoundEnd = False Then Player.SDie.Play DSBPLAY_DEFAULT
        End If
        
        If WickedLife >= 800 Then
            ComWicked.State = "die"
            PicPlayer = 0
            If RoundEnd = False Then ComWicked.SDie.Play DSBPLAY_DEFAULT
        End If
        
        If RoundEnd = False Then
            
            If Player.State = "s" Then ComWicked.State = "w"
            If ComWicked.State = "s" Then Player.State = "w"
            Call WickedPlaying      'affiche l'ennemi
            Call PlayerMove             'affiche le Player
            
            Call CollisionPlayer
            Call CollisionWicked
            If DIstate.Key(DIK_ESCAPE) Then Call Restart
            
        ElseIf ComWicked.State = "die" Then
        
            If PlayerX < WickedX Then
                PlayerY = 150
                Backbuffer.BltFast PlayerX, PlayerY, Player.Wait(2).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
                Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Die(3).ddsdSurface.lWidth, WickedY + ComWicked.Die(3).ddsdSurface.lHeight), ComWicked.Die(3).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
                Backbuffer.BltFast 250, 80, SRound(2), ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                
                If RoundEndTime > 5 Then
                    Call Restart
                End If
                
            Else
                PlayerY = 150
                Backbuffer.BltFast WickedX, WickedY, ComWicked.Die(3).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Wait(2).ddsdSurface.lWidth, PlayerY + Player.Wait(2).ddsdSurface.lHeight), Player.Wait(2).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
                Backbuffer.BltFast 250, 80, SRound(2), ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                RoundEndTime = RoundEndTime + 1
                If RoundEndTime > 5 Then
                    Call Restart
                End If
                
            End If
            
        ElseIf Player.State = "die" Then
        
            If WickedX < PlayerX Then
                WickedY = 150
                Backbuffer.BltFast WickedX, WickedY, ComWicked.Wait(2).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                Backbuffer.BltFx ddRect(PlayerX, PlayerY, PlayerX + Player.Die(Player.NbrPicture).ddsdSurface.lWidth, PlayerY + Player.Die(Player.NbrPicture).ddsdSurface.lHeight), Player.Die(Player.NbrPicture).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
                Backbuffer.BltFast 250, 80, SRound(2), ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                RoundEndTime = RoundEndTime + 1
                If RoundEndTime > 5 Then
                    Call Restart
                End If
                
            Else
                WickedY = 150
                Backbuffer.BltFast PlayerX, PlayerY, Player.Die(Player.NbrPicture).Surface, ddRect(0, 0, 0, 0), DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT
                Backbuffer.BltFx ddRect(WickedX, WickedY, WickedX + ComWicked.Wait(2).ddsdSurface.lWidth, WickedY + ComWicked.Wait(2).ddsdSurface.lHeight), ComWicked.Wait(2).Surface, ddRect(0, 0, 0, 0), DDBLT_KEYSRC Or DDBLT_DDFX Or DDBLT_WAIT, BltFxRevert
                Backbuffer.BltFast 250, 80, SRound(2), ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                RoundEndTime = RoundEndTime + 1
                If RoundEndTime > 5 Then
                    Call Restart
                End If
                
            End If
        End If
        
        Backbuffer.BltFast 0, 5, SBarre, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 0, 20, SBarre, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 500, 5, SBarre, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
        Backbuffer.BltFast 500, 20, SBarre, ddRect(0, 0, 0, 0), DDBLTFAST_WAIT Or DDBLTFAST_SRCCOLORKEY
                
        Primary.Flip Nothing, DDFLIP_WAIT
        
        DoEvents
    Loop Until bRunning = False

End Sub

'Dimension d'une image pour une surface
Public Function ddRect(X1 As Long, Y1 As Long, X2 As Long, Y2 As Long) As RECT
    ddRect.Left = X1
    ddRect.Right = X2
    ddRect.Top = Y1
    ddRect.Bottom = Y2
End Function

'Charger des images jpeg et gif
Public Function CreateSurfaceFromFile(DirectDraw As DirectDraw7, ByVal FileName As String, SurfaceDesc As DDSURFACEDESC2) As DirectDrawSurface7
    Dim Picture As StdPicture
    Dim Width As Long
    Dim Height As Long
    Dim Surface As DirectDrawSurface7
    Dim hdcPicture As Long
    Dim hdcSurface As Long
    
    'On Charge l'image
    Set Picture = LoadPicture(FileName)
    'On convertit les dimensions
    'de vbHimetric vers vbPixel
    Width = CLng((Picture.Width * 0.001) * 567 / Screen.TwipsPerPixelX)
    Height = CLng((Picture.Height * 0.001) * 567 / Screen.TwipsPerPixelY)
       
    'On dfinit les proprit de la description
    With SurfaceDesc
        If .lFlags = 0 Then .lFlags = DDSD_CAPS
        .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
        If .ddscaps.lCaps = 0 Then .ddscaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        If .lWidth = 0 Then .lWidth = Width
        If .lHeight = 0 Then .lHeight = Height
    End With
     
    'On cre la surface DirectDraw
    Set Surface = DirectDraw.CreateSurface(SurfaceDesc)

    'On cre de la Mmoire (pour charger l'image)
    hdcPicture = CreateCompatibleDC(0)

    'On slectionne le Picture et on le copie
    'vers la mmoire cre
    SelectObject hdcPicture, Picture.Handle
      
    'Handle de la surface
    hdcSurface = Surface.GetDC
       
    'On copie l'image contenue dans hdcSurface vers la surface
    StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, hdcPicture, 0, 0, Width, Height, vbSrcCopy
   'On libre l'espace mmoire contenue dans hdcSurface
    Surface.ReleaseDC hdcSurface
    DeleteDC hdcPicture
    
    'On transfre la Surface
    Set CreateSurfaceFromFile = Surface
    
    'On vide Tout !
    Set Picture = Nothing
    Set Surface = Nothing
End Function
